=== autoconf/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/autoconf/Makefile                    */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Thu Jun 19 20:48:50 1997                          */
#*    Last change :  Thu Oct 13 16:03:07 2005 (serrano)                */
#*    Copyright   :  1997-2005 Manuel Serrano, see LICENSE file        */
#*    -------------------------------------------------------------    */
#*    The global autoconf Makefile.                                    */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Flags                                                            */
#*---------------------------------------------------------------------*/
POPULATION	= Makefile \
                  bigloo_config.h.in configure.java.in configure.cs.in \
                  jsm.scm.in \
                  cnstalign longlong llabs strtoll sigpipe sigsetmask \
                  alignment enforcedcnstalign pipe sigsetmask.ucb \
                  alloca getcwd ptrsize stackdown \
                  ascpp getwd ranlib unix dirname \
                  bcopy indent setjmp setjmp.sparc winreg \
                  bigendian ldshare ldpreload ldsoname sigprocmask \
                  sigchld sigaction \
                  doubleprec xemacspath ldstaticopt ldsharedopt \
                  readline ldextraopt socket info cctest ccoptim \
                  ccprof termio installinfo installinfodir dlopen \
                  user xemacsbin gmaketest ccpic ccpic2 \
                  ziptest javatest jartest \
                  os strip cygwindospath select fcntl ccstrip emacsbrand \
                  emacslisppath thread pthread pthreadlock stacksize gcstd \
                  processor dotnettest sendfile sleep posixfileops timezone \
                  gcflags mmap macosx

#*---------------------------------------------------------------------*/
#*    pop ...                                                          */
#*---------------------------------------------------------------------*/
pop:
	@ echo $(POPULATION:%=autoconf/%)

#*---------------------------------------------------------------------*/
#*    clean                                                            */
#*---------------------------------------------------------------------*/
.PHONY: clean cleanall distclean
clean:
	@ find . \( -name '*[~%]'                   \
                       -o -name '.??*[~%]'          \
                       -o -name '#*#'               \
                       -o -name '?*#'               \
                       -o -name \*core \)           \
                     -type f -exec rm {} \;   
	@ echo "cleanup done..."
	@ echo "-------------------------------"

cleanall: clean
distclean: clean

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:
	@ if [ `pwd` = $(BOOTDIR)autoconf ]; then     \
             echo "*** ERROR:Illegal dir to make a distrib `pwd`";   \
             exit 1;                                                 \
          fi
	@ $(MAKE) clean
	@ chmod a+rx $(POPULATION)
	@ /bin/rm -f readline
