=== api/pthread/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/api/pthread/Makefile                 */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Oct  3 05:37:54 2001                          */
#*    Last change :  Fri Nov 11 15:15:05 2005 (serrano)                */
#*    Copyright   :  2001-05 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    This Makefile *requires* GNU-Make.                               */
#*    -------------------------------------------------------------    */
#*    The Makefile for pthread                                         */
#*=====================================================================*/
include ../../Makefile.config

#*---------------------------------------------------------------------*/
#*    Directories where to find the files composing a revision         */
#*---------------------------------------------------------------------*/
POPDIR		= src recette recette2

POPULATION	= Makefile README

#*---------------------------------------------------------------------*/
#*    all                                                              */
#*---------------------------------------------------------------------*/
all: boot-c boot-jvm boot-dotnet
boot: boot-c boot-jvm boot-dotnet

boot-c:
	@ if [ "$(PTHREADLIBS)" = "no" ]; then \
          echo "[0m[1;32m>>> No native support[0m"; \
        else \
	  if [ "$(CGCTHREADFLAGS)" = "no" ]; then \
            echo "[0m[1;32m>>> No native support[0m"; \
          else \
	    echo "[0m[1;32m>>> C[0m"; \
	    (cd src && $(MAKE) c) || exit 1; \
            if [ "$(GCCUSTOM)" = "yes" ]; then \
              (cd ../../runtime && $(MAKE) gc_fth) \
            fi \
          fi \
        fi

boot-jvm:
	@ echo "[0m[1;31m>>> JVM[0m";
	(cd src && $(MAKE) jvm)

boot-dotnet:
	@ echo "[0m[1;31m>>> .NET[0m";
	(cd src && $(MAKE) dotnet)

#*---------------------------------------------------------------------*/
#*    ude                                                              */
#*---------------------------------------------------------------------*/
ude:
	(cd src && $(MAKE) ude)

#*---------------------------------------------------------------------*/
#*    pop                                                              */
#*    -------------------------------------------------------------    */
#*    This entry is used by the bigloo/Makefile (the main Bigloo       */
#*    makefile) to get the list of file that populate a revision.      */
#*---------------------------------------------------------------------*/
.PHONY: pop
pop:
	@ echo $(POPULATION:%=pthread/%)
	@ for d in $(POPDIR); do \
            (cd $$d && $(MAKE) -s pop) \
          done;

#*---------------------------------------------------------------------*/
#*    Clean                                                            */
#*---------------------------------------------------------------------*/
clean:
	(cd src && $(MAKE) clean)
	(cd recette && $(MAKE) clean)

distclean: clean
	(cd src && $(MAKE) distclean)
	(cd recette && $(MAKE) distclean)

cleanall: distclean
	(cd src && $(MAKE) cleanall)
	$(RM) -f lib/*pth* >/dev/null 2>&1
	$(RM) -f *~ >/dev/null 2>&1

#*---------------------------------------------------------------------*/
#*    Installation                                                     */
#*---------------------------------------------------------------------*/
.PHONY: install install-c install-jvm uninstall

include ../../Makefile.misc

install: install-init install-c install-jvm install-dotnet

install-init:
	if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	  cp $(BOOTLIBDIR)/pthread.init $(DESTDIR)$(FILDIR)/pthread.init && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/pthread.init; \
        fi

install-c:
	if [ "$(PTHREADLIBS)" != "no" ]; then \
	  if [ "$(CGCTHREADFLAGS)" != "no" ]; then \
	    (cd ../../runtime && $(MAKE) install-thread); \
	    if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	      cp $(BOOTLIBDIR)/pthread.heap $(DESTDIR)$(FILDIR)/pthread.heap && \
	      chmod $(BMASK) $(DESTDIR)$(FILDIR)/pthread.heap; \
            fi; \
	    $(MAKE) install-lib LIB=libbigloopth_s-$(RELEASE); \
	    $(MAKE) install-shared-lib LIB=libbigloopth_e-$(RELEASE); \
	    $(MAKE) install-lnlib LIB=libbigloopth_s-$(RELEASE) LN=libbigloopth_u-$(RELEASE); \
          fi; \
        fi

install-jvm:
	if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	  cp $(BOOTLIBDIR)/pthread.jheap $(DESTDIR)$(FILDIR)/pthread.jheap && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/pthread.jheap && \
	  cp $(BOOTLIBDIR)/bigloopth_s-$(RELEASE).zip $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).zip && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).zip && \
	  (cd $(DESTDIR)$(FILDIR) && \
           $(RM) -f bigloopth_u-$(RELEASE).zip && \
           ln bigloopth_s-$(RELEASE).zip bigloopth_u-$(RELEASE).zip); \
	  (cd $(DESTDIR)$(FILDIR) && \
           $(RM) -f bigloopth_e-$(RELEASE).zip && \
           ln bigloopth_s-$(RELEASE).zip bigloopth_e-$(RELEASE).zip); \
        fi

install-dotnet:
	if [ $(DESTDIR)$(FILDIR) != $(BOOTLIBDIR) ]; then \
	  cp $(BOOTLIBDIR)/pthread.jheap $(DESTDIR)$(FILDIR)/pthread.jheap && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/pthread.jheap && \
	  cp $(BOOTLIBDIR)/bigloopth_s-$(RELEASE).dll $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).dll && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).dll && \
	  cp $(BOOTLIBDIR)/bigloopth_u-$(RELEASE).dll $(DESTDIR)$(FILDIR)/bigloopth_u-$(RELEASE).dll && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloopth_u-$(RELEASE).dll ; \
	  cp $(BOOTLIBDIR)/bigloopth_e-$(RELEASE).dll $(DESTDIR)$(FILDIR)/bigloopth_e-$(RELEASE).dll && \
	  chmod $(BMASK) $(DESTDIR)$(FILDIR)/bigloopth_e-$(RELEASE).dll ; \
        fi

uninstall:
	-$(RM) -f $(DESTDIR)$(FILDIR)/pthread.init
	-$(RM) -f $(DESTDIR)$(FILDIR)/pthread.heap
	-$(MAKE) uninstall-lib LIB=libbigloopth_s-$(RELEASE)
	-$(MAKE) uninstall-lib LIB=libbigloopth_u-$(RELEASE)
	-$(MAKE) uninstall-lib LIB=libbigloopth_e-$(RELEASE)
	-$(RM) -f $(DESTDIR)$(FILDIR)/pthread.jheap
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).zip
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_u-$(RELEASE).zip
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_e-$(RELEASE).zip
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_s-$(RELEASE).dll
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_u-$(RELEASE).dll
	-$(RM) -f $(DESTDIR)$(FILDIR)/bigloopth_e-$(RELEASE).dll

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:
	(cd src && $(MAKE) ude)
