=== bdb/bdb/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/bdb/bdb/Makefile                     */
#*    -------------------------------------------------------------    */
#*    Author      :  serrano                                           */
#*    Creation    :  Wed Jul 28 06:59:47 1999                          */
#*    Last change :  Mon Oct 31 15:23:15 2005 (serrano)                */
#*    -------------------------------------------------------------    */
#*    Automatically generated file:                                    */
#*       bmake                                                         */
#*          -fapplication                                              */
#*          -main                                                      */
#*          Init/main.scm                                              */
#*          -o                                                         */
#*          Makefile                                                   */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    The default configuration                                        */
#*---------------------------------------------------------------------*/
include ../../Makefile.config

#*---------------------------------------------------------------------*/
#*    Target and Project                                               */
#*---------------------------------------------------------------------*/
PROJECT		= src
VERSION		= 0
TARGET_DIR      = $(BOOTBINDIR)
TARGET_NAME     = bdb

#*---------------------------------------------------------------------*/
#*    The project mode (either `devel' or `final').                    */
#*---------------------------------------------------------------------*/
MODE		= final

#*---------------------------------------------------------------------*/
#*    Compilers, Flags and Tools ...                                   */
#*---------------------------------------------------------------------*/
# The Bigloo compiler
BIGLOO          = $(BOOTBINDIR)/bigloo
BFLAGS_COMMON   = -afile $(AFILE) -no-hello -L $(BOOTLIBDIR)
BFLAGS_G        = $(BFLAGS_COMMON) -g2
BFLAGS_O        = $(BFLAGS_COMMON) -O5 #-O5 -unsafe
BFLAGS_P        = $(BFLAGS_COMMON) -O5 -unsafe -static-bigloo -p
BFLAGS_P2       = $(BFLAGS_COMMON) -O5 -unsafe -static-bigloo -p2
BFLAGS          = $(BFLAGS_G)
LNFLAGS_G       = 
LNFLAGS_O       = -s
LNFLAGS_P       = 
LNFLAGS         = $(LNFLAGS_G)
# The mco builder (this could be Bigloo itself or a speciliazed tools)
MCO_EXE		= ../../bin/mco
MCOFLAGS	= -I . -s # when using Bigloo, add the -mco flags here
# The interface builder
BUILDER		= buildoo
BLNFLAGS	= -no-event-loop --generate
# The C compiler
TK_LIB		= $$HOME/prgm/project/bglk/tk
CFLAGS_O	= $(CFLAGS)
# Which shell to use
SHELL           = /bin/sh
# Revision system
PRCS            = prcs
COMPRESS        = gzip
# Afile
AFILE_EXE       = afile
AFILE		= .afile
# Tags
TAGS_EXE	= btags
TAGS		= .etags
# Depend
DEPEND_EXE	= bdepend
BMAKE_EXE	= bmake
# Profiling
BPROF_EXE	= bprof
PROF		= PROF
PROFILE_ARGS	= 

#*---------------------------------------------------------------------*/
#*    Suffixes ...						       */
#*---------------------------------------------------------------------*/
.SUFFIXES:

#*---------------------------------------------------------------------*/
#*    Automatic rules ...					       */
#*    -------------------------------------------------------------    */
#*    One may add some automatic rules. Before explicit rules, we      */
#*    were making use of:                                              */
#*    -------------------------------------------------------------    */
#* %.o: %.scm                                                          */
#* 	@ $(BIGLOO) $(BFLAGS) -c $*.scm -o $*.o                        */
#*                                                                     */
#* %_p.o: %.scm                                                        */
#* 	@ $(BIGLOO) $(BFLAGS_P) -c $*.scm -o $*_p.o                    */
#*                                                                     */
#* %.mco:                                                              */
#* 	@ $(BIGLOO) $(BFLAGS) -s -mco $*.scm -o $*.mco                 */
#*                                                                     */
#* %.o: %.c                                                            */
#* 	@ echo $*.c:; $(CC) $(CFLAGS) -c $*.c -o $*.o                  */
#*                                                                     */
#* %_p.o: %.c                                                          */
#* 	@ echo $*.c:; $(CC) $(CFLAGS_P) -c $*.c -o $*.o; mv $*.o $@    */
#*                                                                     */
#* %_p.mco:                                                            */
#* 	@ $(BIGLOO) $(BFLAGS) -s -mco $*.scm -o $*_p.mco               */
#*                                                                     */
#* %.scm: %.bld                                                        */
#* 	@ $(BUILDER) $(BLNFLAGS) $*.bld -o $*.scm                      */
#*---------------------------------------------------------------------*/

#*---------------------------------------------------------------------*/
#*    Objects and sources ...					       */
#*---------------------------------------------------------------------*/
OBJECTS = Command/command.mco Command/explore.mco Init/setrc.mco        \
      Command/parse.mco Gdb/gread.mco Gdb/tools.mco Engine/engine.mco   \
      Command/set.mco Bee/etags.mco Tools/error.mco                     \
      Command/backtrace.mco Patient/value.mco Gdb/annotate.mco          \
      Gdb/autoconf.mco Engine/param.mco Tools/version.mco               \
      Command/display.mco Engine/repl.mco Gdb/ginvoke.mco               \
      Patient/server.mco Command/run.mco Tools/speek.mco                \
      Command/all-cmd.mco Tools/date.mco Init/parse-args.mco            \
      Tools/io.mco Command/help.mco Command/print.mco                   \
      Patient/mangling.mco Command/whatis.mco Tools/tools.mco           \
      Patient/pinvoke.mco Command/file.mco Command/break.mco            \
      Command/mangle.mco Gdb/proc.mco Command/expr.mco Command/info.mco \
      Bee/binvoke.mco Command/quit.mco Init/main.mco Command/command.o  \
      Command/explore.o Init/setrc.o Command/parse.o Gdb/gread.o        \
      Gdb/tools.o Engine/engine.o Command/set.o Bee/etags.o             \
      Tools/error.o Command/backtrace.o Patient/value.o Gdb/annotate.o  \
      Gdb/autoconf.o Engine/param.o Tools/version.o Command/display.o   \
      Engine/repl.o Gdb/ginvoke.o Patient/server.o Command/run.o        \
      Tools/speek.o Command/all-cmd.o Tools/date.o Init/parse-args.o    \
      Tools/io.o Command/help.o Command/print.o Patient/mangling.o      \
      Command/whatis.o Tools/tools.o Patient/pinvoke.o Command/file.o   \
      Command/break.o Command/mangle.o Gdb/proc.o Command/expr.o        \
      Command/info.o Bee/binvoke.o Command/quit.o Init/main.o           \
      Tools/tty.o 
GUI_OBJECTS = 
OBJECTS_P = Command/command_p.mco Command/explore_p.mco                 \
      Init/setrc_p.mco Command/parse_p.mco Gdb/gread_p.mco              \
      Gdb/tools_p.mco Engine/engine_p.mco Command/set_p.mco             \
      Bee/etags_p.mco Tools/error_p.mco Command/backtrace_p.mco         \
      Patient/value_p.mco Gdb/annotate_p.mco Gdb/autoconf_p.mco         \
      Engine/param_p.mco Tools/version_p.mco Command/display_p.mco      \
      Engine/repl_p.mco Gdb/ginvoke_p.mco Patient/server_p.mco          \
      Command/run_p.mco Tools/speek_p.mco Command/all-cmd_p.mco         \
      Tools/date_p.mco Init/parse-args_p.mco Tools/io_p.mco             \
      Command/help_p.mco Command/print_p.mco Patient/mangling_p.mco     \
      Command/whatis_p.mco Tools/tools_p.mco Patient/pinvoke_p.mco      \
      Command/file_p.mco Command/break_p.mco Command/mangle_p.mco       \
      Gdb/proc_p.mco Command/expr_p.mco Command/info_p.mco              \
      Bee/binvoke_p.mco Command/quit_p.mco Init/main_p.mco              \
      Command/command_p.o Command/explore_p.o Init/setrc_p.o            \
      Command/parse_p.o Gdb/gread_p.o Gdb/tools_p.o Engine/engine_p.o   \
      Command/set_p.o Bee/etags_p.o Tools/error_p.o                     \
      Command/backtrace_p.o Patient/value_p.o Gdb/annotate_p.o          \
      Gdb/autoconf_p.o Engine/param_p.o Tools/version_p.o               \
      Command/display_p.o Engine/repl_p.o Gdb/ginvoke_p.o               \
      Patient/server_p.o Command/run_p.o Tools/speek_p.o                \
      Command/all-cmd_p.o Tools/date_p.o Init/parse-args_p.o            \
      Tools/io_p.o Command/help_p.o Command/print_p.o                   \
      Patient/mangling_p.o Command/whatis_p.o Tools/tools_p.o           \
      Patient/pinvoke_p.o Command/file_p.o Command/break_p.o            \
      Command/mangle_p.o Gdb/proc_p.o Command/expr_p.o Command/info_p.o \
      Bee/binvoke_p.o Command/quit_p.o Init/main_p.o Tools/tty_p.o 
SOURCES = Tools/tty.c Command/command.scm Command/explore.scm           \
      Init/setrc.scm Command/parse.scm Gdb/gread.scm Gdb/tools.scm      \
      Engine/engine.scm Command/set.scm Bee/etags.scm Tools/error.scm   \
      Command/backtrace.scm Patient/value.scm Gdb/annotate.scm          \
      Gdb/autoconf.scm Engine/param.scm Tools/version.scm               \
      Command/display.scm Engine/repl.scm Gdb/ginvoke.scm               \
      Patient/server.scm Command/run.scm Tools/speek.scm                \
      Command/all-cmd.scm Tools/date.scm Init/parse-args.scm            \
      Tools/io.scm Command/help.scm Command/print.scm                   \
      Patient/mangling.scm Command/whatis.scm Tools/tools.scm           \
      Patient/pinvoke.scm Command/file.scm Command/break.scm            \
      Command/mangle.scm Gdb/proc.scm Command/expr.scm Command/info.scm \
      Bee/binvoke.scm Command/quit.scm Init/main.scm 
SOURCES_C = Command/command.c Command/explore.c Init/setrc.c            \
      Command/parse.c Gdb/gread.c Gdb/tools.c Engine/engine.c           \
      Command/set.c Bee/etags.c Tools/error.c Command/backtrace.c       \
      Patient/value.c Gdb/annotate.c Gdb/autoconf.c Engine/param.c      \
      Tools/version.c Command/display.c Engine/repl.c Gdb/ginvoke.c     \
      Patient/server.c Command/run.c Tools/speek.c Command/all-cmd.c    \
      Tools/date.c Init/parse-args.c Tools/io.c Command/help.c          \
      Command/print.c Patient/mangling.c Command/whatis.c Tools/tools.c \
      Patient/pinvoke.c Command/file.c Command/break.c Command/mangle.c \
      Gdb/proc.c Command/expr.c Command/info.c Bee/binvoke.c            \
      Command/quit.c Init/main.c 
POPULATION = $(SOURCES) Makefile Engine/hooks.sch

#*---------------------------------------------------------------------*/
#*    trashcan ...						       */
#*---------------------------------------------------------------------*/
All: all
all: mode
mode:
	$(MAKE) $(MODE)

main: $(TARGET_DIR)/$(TARGET_NAME)
$(TARGET_DIR)/$(TARGET_NAME): $(GUI_OBJECTS) $(OBJECTS)
	@ echo "Linking..."
	@ $(BIGLOO) $(BFLAGS) $(LNFLAGS) $(OBJECTS) -o $(TARGET_DIR)/$(TARGET_NAME)
	@ echo "$(TARGET_DIR)/$(TARGET_NAME) done."
	@ echo "-------------------------------"

devel: $(TARGET_DIR)
	@ $(MAKE) -f Makefile main BFLAGS="$(BFLAGS_G)" LNFLAGS="$(LNFLAGS_G)" CFLAGS="$(CFLAGS_G)"

final: $(TARGET_DIR)
	@ $(MAKE) -f Makefile main BFLAGS="$(BFLAGS_O)" LNFLAGS="$(LNFLAGS_O)" CFLAGS="$(CFLAGS_O)"

profile_comp: $(TARGET_DIR) main_p
main_p: forceafile forcetags $(TARGET_DIR)/$(TARGET_NAME)_p
$(TARGET_DIR)/$(TARGET_NAME)_p: $(OBJECTS_P)
	@ echo "Linking..."
