=== debian/changelog ===
bigloo (2.7a-1) unstable; urgency=low

  * Final upstream release.
  * Reactivated ia64 build, since #336918 is believed to be fixed.

 -- Yann Dirson <dirson@debian.org>  Mon, 21 Nov 2005 20:51:46 +0100

bigloo (2.6f+2.7a-051116-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Wed, 16 Nov 2005 21:34:48 +0100

bigloo (2.6f+2.7a-051105-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Sun,  6 Nov 2005 16:01:43 +0100

bigloo (2.6f+2.7a-051027-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Fri, 28 Oct 2005 18:53:20 +0200

bigloo (2.6f+2.7a-051026-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Wed, 26 Oct 2005 19:23:58 +0200

bigloo (2.6f+2.7a-051022-1) unstable; urgency=low

  * New upstream beta release.

 -- Yann Dirson <dirson@debian.org>  Sat, 22 Oct 2005 14:42:39 +0200

bigloo (2.6f+2.7a-051017-1) unstable; urgency=low

  * New upstream beta release.
  * Run the tests after build to get an idea of the results on all
    platforms (only the jvm mmap test fails on i386).  
  * Added note in README.Debian about the missing mmap feature in the jvm.

 -- Yann Dirson <dirson@debian.org>  Mon, 17 Oct 2005 20:36:12 +0200

bigloo (2.6f+2.7a-051013-2) unstable; urgency=low

  * Switch to free-java-sdk, instead of requesting individual packages
    (this means we will use jikes instead of kaffe), both in build-deps
    and backend-jvm deps.

 -- Yann Dirson <dirson@debian.org>  Sat, 15 Oct 2005 14:53:47 +0200

bigloo (2.6f+2.7a-051013-1) unstable; urgency=low

  * New upstream beta release.
  * Use conditionnal dh_install to install jigloo, instead of conditionnal
    cp and subsequent unconditionnal dh_movefiles, which caused errors.
  * Removed mips from the list of archs supporting jvm backend, since
    there is no gcj there, and the future of kaffe support on that arch is
    uncertain anyway.
  * Added missing .gz suffix to info index filenames in doc-base files (linda).

 -- Yann Dirson <dirson@debian.org>  Sat, 15 Oct 2005 00:03:05 +0200

bigloo (2.6f+2.7a-051012-1) unstable; urgency=low

  * New upstream beta release.
  * Do not try to put jigloo in the package on archs where we do not build
    it.

 -- Yann Dirson <dirson@debian.org>  Wed, 12 Oct 2005 23:00:58 +0200

bigloo (2.6f+2.7a-051005-3) unstable; urgency=low

  * Only attempt to build jigloo on jvm-enabled platforms.

 -- Yann Dirson <dirson@debian.org>  Sun,  9 Oct 2005 15:55:21 +0200

bigloo (2.6f+2.7a-051005-2) unstable; urgency=low

  * Disabled jvm backend on mipsel, where no kaffe/gcj is available for
    now.
  * Tuned build-deps to avoid java-related stuff on platforms where we do
    not build the jvm backend.
  * Put bigloo-doc in section doc to match the override.

 -- Yann Dirson <dirson@debian.org>  Sat,  8 Oct 2005 17:46:40 +0200

bigloo (2.6f+2.7a-051005-1) unstable; urgency=low

  * New upstream beta release, fixing an issue with gcc 4.x.  Dropped the
    dependencies on gcc-3.4.

 -- Yann Dirson <dirson@debian.org>  Wed,  5 Oct 2005 21:22:02 +0200

bigloo (2.6f+2.7a-050920-1) unstable; urgency=low

  * New upstream beta release.
  * Added alpha to the arch list for jvm backend, now that kaffe/#328328
    is fixed.
  * Removed build-dep on fastjar, which was not used anyway, now that
    kaffe uses fastjar itself.

 -- Yann Dirson <dirson@debian.org>  Sat, 24 Sep 2005 14:23:41 +0200

bigloo (2.6f+2.7a-050916-2) unstable; urgency=low

  * Be sure not to attempt to build the deb of the jvm backend where
    disabled.

 -- Yann Dirson <dirson@debian.org>  Sat, 17 Sep 2005 10:05:22 +0200

bigloo (2.6f+2.7a-050916-1) unstable; urgency=low

  * New upstream beta release.
  * Desactivate build of jvm backend for platforms with known problems:
    sparc (sablevm #328311), ia64 (sablevm), alpha (kaffe/jar #328328),
    m68k (already on build-ignore list).  
  * Pass --jvm flag to configure based on debian/control Architecture
    field.

 -- Yann Dirson <dirson@debian.org>  Fri, 16 Sep 2005 20:34:26 +0200

bigloo (2.6f+2.7a-050818-5) unstable; urgency=low

  * Have bigloo-backend-native depend on gcc-3.4 instead of just gcc
    (Closes: #327318).

 -- Yann Dirson <dirson@debian.org>  Sat, 10 Sep 2005 13:44:19 +0200

bigloo (2.6f+2.7a-050818-4) unstable; urgency=low

  * Added fastjar to build-depends.

 -- Yann Dirson <dirson@debian.org>  Mon,  5 Sep 2005 19:18:11 +0200

bigloo (2.6f+2.7a-050818-3) unstable; urgency=low

  * Added zip to build-depends (Closes: #319297).

 -- Yann Dirson <dirson@debian.org>  Sun,  4 Sep 2005 15:26:20 +0200

bigloo (2.6f+2.7a-050818-2) unstable; urgency=low

  * Restored the build-deps for previously-disabled jvm backend.
  * Build jigloo before bigloo, so that if gcj fails the buildd time is
    not wasted uselessly.

 -- Yann Dirson <dirson@debian.org>  Sat, 20 Aug 2005 23:57:41 +0200

bigloo (2.6f+2.7a-050818-1) unstable; urgency=low

  * New upstream beta release.
  * Reactivated the build of the jvm backend.

 -- Yann Dirson <dirson@debian.org>  Sat, 20 Aug 2005 18:10:35 +0200

bigloo (2.6f+2.7a-050721-1) unstable; urgency=low

  * New upstream beta release.
  * Restored build-dep on gcj to get jigloo built.

 -- Yann Dirson <dirson@debian.org>  Thu, 21 Jul 2005 21:32:07 +0200

bigloo (2.6f+2.7a-050720-1) unstable; urgency=low

  * New upstream beta release.
  * Deactivated build of java backend, until kaffe gets updated - we need
    to tackle other problems first.  The jvm package is still built but
    empty, with a note in the description.

 -- Yann Dirson <dirson@debian.org>  Wed, 20 Jul 2005 21:41:31 +0200

bigloo (2.6f+2.7a-050708-4) unstable; urgency=low

  * Use kaffe as javac and sablevm as java, as those look like the
    prefered ones.  Adapted build-deps accordingly.

 -- Yann Dirson <dirson@debian.org>  Mon, 18 Jul 2005 01:52:50 +0200

bigloo (2.6f+2.7a-050708-3) unstable; urgency=low


