=== debian/control ===
Source: bigloo
Section: interpreters
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper (>= 4.1.1), dh-buildinfo, texinfo, dbs, gcj [!sparc !mipsel !mips], libgcj6-dev [!sparc !mipsel !mips], free-java-sdk [!sparc !mipsel !mips], zip [!sparc !mipsel !mips]
Build-Depends-Indep: skribe
Standards-Version: 3.6.2

Package: bigloo
Architecture: any
Depends: ${shlibs:Depends}, bigloo-backend-native | bigloo-backend, ${bigloo:Runtime}
Recommends: bigloo-backend-native
Suggests: bigloo-devtools, bigloo-ude
Description: A practical Scheme compiler
 Bigloo is a Scheme system which includes a compiler generating 
 C, java, or .NET code, and an interpreter.
 .
 Bigloo conforms to IEEE Scheme and is mostly conformant to Revised^5
 Report on the Algorithmic Language Scheme with many extensions:
  - SRFI 0, 2, 6, 8, 9, 18, 22, 28, and support for using the
  reference implementations of other SRFIs.
  - Rgc, a lex facility.
  - Match, a pattern-matching compiler.
  - Foreign languages interface.
  - Module language.
  - Extension package system.
  - An LALR facility.
  - An Object system.
  - Some DSSSL support features.
  - Unicode characters and strings.
  - Process, Pipe and Socket support.

Package: libbigloo2.7a
Architecture: any
Section: libs
Depends: ${shlibs:Depends}
Description: Run-time libraries for Bigloo-generated programs
 Provides the shared run-time libraries that enable programs
 compiled with this version of Bigloo to be run, without needing
 to have the full compiler installed.

Package: bigloo-backend-native
Architecture: any
Provides: bigloo-backend
Depends: bigloo (= ${Source-Version}), gcc, libc6-dev
Conflicts: bigloo (<= 2.6f+2.7a-050708-1)
Replaces: bigloo (<= 2.6f+2.7a-050708-1)
Description: Bigloo support to build native executables
 Provides the support files to compile scheme programs into native
 executables using bigloo.

Package: bigloo-backend-jvm
Architecture: i386 powerpc s390 amd64 arm hppa alpha ia64
X-BrokenJVM-Architectures: sparc (sablevm #328311) ia64 (sablevm #336918, maybe fixed now) m68k (does not build anyway) mipsel (no gcj, no kaffe) mips (no gcj)
Provides: bigloo-backend
Depends: bigloo (= ${Source-Version}), free-java-sdk
Description: Bigloo support to build JVM bytecode
 Provides the support files to compile scheme programs into JVM
 bytecode using bigloo.

Package: bigloo-devtools
Architecture: any
Depends: bigloo (>= 2.4b-3), ${shlibs:Depends}
Suggests: bigloo-ude
Description: Tools to help developping Bigloo programs
 A couple of development tools are provided for Bigloo.  Since they
 are not necessary for building a package, but are "only" useful for
 people intending to write, debug, or modify bigloo programs, they are
 shipped in a separate package.
 .
 These tools include:
  * bdb: the Bigloo debugger
  * cigloo: a declaration builder for interfacing with C code

Package: bigloo-ude
Architecture: all
Depends: bigloo (>= 2.4b-3), xemacs21 | emacs21, make
Suggests: prcs, texinfo, bigloo-devtools, binutils
Description: Bigloo Unified Development Environment for Emacs
 A development environment for the Bigloo scheme compiler, targeted to
 XEmacs and GNU Emacs21.

Package: bigloo-doc
Architecture: all
Section: doc
Suggests: bigloo
Replaces: bigloo (<= 2.5a+really2.5b-beta-2002-07-26-3), bigloo-devtools (<= 2.5b-1)
Description: Documentation for the Bigloo scheme compiler
 This is the documentation for Bigloo and its development environment,
 in HTML and info formats.

Package: bigloo-examples
Architecture: all
Recommends: bigloo
Description: Examples for the Bigloo scheme compiler
 This is the set of examples from the Bigloo distribution.
