=== debian/watch ===
version=2
opts=passive ftp://ftp-sop.inria.fr/mimosa/fp/Bigloo/bigloo([0-9].*).tar.gz
